﻿using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Input;

namespace TreeViewSample
{
    public class MainPageVM : BindableBase
    {
        private readonly IList<CommonM> _allItems = new List<CommonM>();
        private ICommand _loadedCommand;
        private ICommand _selectionChangedCommand;
        private IList<CommonM> _treeViewBindingList;

        public IList<CommonM> TreeViewBindingList
        {
            get { return _treeViewBindingList; }
            set { SetProperty(ref _treeViewBindingList, value); }
        }

        /// <summary>
        ///     셀렉션 체인지 커맨드
        /// </summary>
        public ICommand SelectionChangedCommand
        {
            get { return _selectionChangedCommand = _selectionChangedCommand ?? new DelegateCommand(obj => { }); }
        }

        public ICommand LoadedCommand
        {
            get
            {
                return _loadedCommand = _loadedCommand ?? new DelegateCommand(obj =>
                {
                    var subList = new List<CommonM>
                    {
                        new CommonM {Id = "01", Name = "Sub01"},
                        new CommonM {Id = "02", Name = "Sub02"},
                        new CommonM {Id = "03", Name = "Sub03"},
                        new CommonM {Id = "04", Name = "Sub04"},
                        new CommonM {Id = "05", Name = "Sub05"}
                    };
                    var add = (from kkk in subList
                        select AddItem((IList) _allItems, kkk)).Count();
                    var root = new CommonM {Id = "00", Name = "Root", ValueObject = subList};
                    AddItem((IList) _allItems, root);

                    TreeViewBindingList = new List<CommonM>
                    {
                        root
                    };
                });
            }
        }

        private bool AddItem(IList list, object item)
        {
            if (list.Contains(item)) return false;
            list.Add(item);
            return true;
        }
    }
}